<?php

/**
 * @file
 * Builds placeholder replacement tokens for opigno_certificate_pdf_form.
 */

use Drupal\Core\Render\BubbleableMetadata;

/**
 * Implements hook_token_info().
 */
function opigno_certificate_pdf_form_token_info() {
  $group = [];
  $group['completed_on'] = [
    'name' => t('Completed on'),
    'type' => 'entity',
  ];

  return [
    'tokens' => ['group' => $group],
  ];
}

/**
 * Implements hook_tokens().
 */
function opigno_certificate_pdf_form_tokens($type, $tokens, array $data, array $options, BubbleableMetadata $bubbleable_metadata) {
  $replacements = [];

  if ($type == 'group' && !empty($data['group'])) {
    foreach ($tokens as $name => $original) {
      switch ($name) {
        case 'completed_on':
          $lp_status = \Drupal::service('opigno_learning_path.training_manager')->getLearningPathStatus($data['group'], \Drupal::currentUser());
          $finished = $lp_status->get('finished')->value;
          if ($lp_status && $finished) {
            $date_formatter = \Drupal::service('date.formatter');
            $replacements[$original] = $date_formatter->format($finished, 'us_short_date');
            break;
          }
      }
    }
  }

  return $replacements;
}
