<?php

namespace Drupal\opigno_discussion_activity\EventSubscriber;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Tracker route subscriber.
 */
class TrackerRouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    $user_routes = [
      'tracker.users_recent_content',
      'tracker.user_tab',
    ];
    // Harden permissions to admin users for user tracker routes.
    foreach ($user_routes as $route_name) {
      if ($route = $collection->get($route_name)) {
        $route->setRequirement('_permission', 'administer users');
      }
    }
    // Hide the generic tracker page.
    if ($route = $collection->get('tracker.page')) {
      $route->setRequirement('_access', 'FALSE');
    }
  }

}
