<?php

/**
 * @file
 * Post update functions for opigno_group_manager.
 */

use Drupal\Core\Site\Settings;

/**
 * Move LMS link data to group managed content.
 */
function opigno_group_manager_post_update_module_relationship_data(&$sandbox) {
  $link_storage = \Drupal::entityTypeManager()->getStorage('opigno_group_link');

  if (!\array_key_exists('list', $sandbox)) {
    $sandbox['list'] = $link_storage
      ->getQuery()
      ->accessCheck(FALSE)
      ->execute();
    $sandbox['total'] = \count($sandbox['list']);
    $sandbox['progress'] = 0;
  }

  for ($i = 0; $i < Settings::get('entity_update_batch_size', 50); $i++) {
    if (\count($sandbox['list']) === 0) {
      break;
    }

    $id = array_pop($sandbox['list']);
    $link = $link_storage->load($id);
    $parent_content = $link->get('parent_content_id')->entity;
    $child_content = $link->get('child_content_id')->entity;
    if ($parent_content !== NULL && $child_content !== NULL) {
      $parents_field = $child_content->get('parents');
      $parents_field->appendItem([
        'target_id' => $parent_content->id(),
      ]);
      $child_content->save();
    }

    $sandbox['progress']++;
    $sandbox['#finished'] = $sandbox['progress'] / $sandbox['total'];
  }

  \Drupal::logger('opigno_learning_path')->notice('Updated @count Group Managed Content entities. @remaining remaining.', [
    '@count' => $sandbox['progress'],
    '@remaining' => $sandbox['total'] - $sandbox['progress'],
  ]);
}
