(function ($, Drupal) {
  Drupal.behaviors.opignoJournalingActivityCharCount = {
    attach: function(context) {
      $('.field-journaling-min-char').once('char-count').each(function() {
        // Get the minimum required chars.
        var minChar = parseInt($(this).text());

        CKEDITOR.on('instanceReady', function(event) {
          var instance = event.editor;
          var total = instance.document.getBody().getText().replace(/[\n\r]/g, '').length;
          var $element = $(instance.element.$);
          var parent = $element.parents('.field--name-field-journal-answers .js-form-type-textarea');
          var $counter = $('<div class="journaling-char-counter">' + Drupal.t('Total characters (min @min): <strong class="total">@total</strong>', {'@total': total, '@min': minChar}) + '</div>');
          parent.prepend($counter);
          instance.counter = $counter;
          instance.on('change', function(event) {
            var target = event.editor;
            var total = target.document.getBody().getText().replace(/[\n\r]/g, '').length;
            $('.total', target.counter).text(total);
          });
        });
      });
    }
  };
})(jQuery, Drupal);
