<?php

namespace Drupal\opigno_journaling_activity\Plugin\ActivityAnswer;

use Drupal\Component\Render\PlainTextOutput;
use Drupal\Core\Entity\Controller\EntityViewController;
use Drupal\opigno_module\ActivityAnswerPluginBase;
use Drupal\opigno_module\Entity\OpignoActivityInterface;
use Drupal\opigno_module\Entity\OpignoAnswerInterface;
use Drupal\Component\Utility\Xss;

/**
 * Class JournalingAnswerActivityAnswer.
 *
 * @ActivityAnswer(
 *   id="opigno_journaling_activity",
 * )
 */
class JournalingAnswerActivityAnswer extends ActivityAnswerPluginBase {

  /**
   * {@inheritdoc}
   */
  public function evaluatedOnSave(OpignoActivityInterface $activity) {
    // Answer must be evaluated manually.
    return FALSE;
  }

  /**
   * {@inheritdoc}
   */
  public function getScore(OpignoAnswerInterface $answer) {
    return 0;
  }

  /**
   * {@inheritdoc}
   */
  public function getAnswerResultItemHeaders(OpignoAnswerInterface $answer) {
    return [$this->t('Question'), $this->t('Your answer')];
  }

  /**
   * {@inheritdoc}
   */
  public function getAnswerResultItemData(OpignoAnswerInterface $answer) {
    $data = [];

    $activity = $answer->getActivity();
    $questions = $activity->get('field_journaling_questions')->getValue();

    foreach ($answer->get('field_journal_answers')->getValue() as $index => $value) {
      $data[] = [
        Xss::filter($questions[$index]['value']),
        Xss::filter($value['value']),
      ];
    }

    return $data;
  }
}
