<?php
namespace Drupal\opigno_journaling_activity\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if ($route = $collection->get('view.journal_entries.page_1')) {
      $parameters = $route->getOption('parameters');
      $parameters['group']['bundle'] = ['learning_path'];
      $route->setOption('parameters', $parameters);
    }
    if ($route = $collection->get('view.journal_entries.page_2')) {
      $parameters = $route->getOption('parameters');
      $parameters['group']['bundle'] = ['learning_path'];
      $route->setOption('parameters', $parameters);
      $route->setRequirement('_custom_access', '_opigno_journaling_activity_my_journals_access');
    }
  }

}
