<?php

namespace Drupal\opigno_learning_path\Cache\Context;

use Drupal\Core\Cache\CacheableMetadata;
use Drupal\Core\Cache\Context\CacheContextInterface;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\opigno_learning_path\Context\TrainingContextTrait;

/**
 * Defines the OpignoCurrentCacheContext service.
 *
 * Cache context ID: 'lms_training'.
 */
class TrainingCacheContext implements CacheContextInterface {

  use StringTranslationTrait;
  use TrainingContextTrait;

  /**
   * Constructs a new TrainingCacheContext.
   */
  public function __construct(
    protected readonly RouteMatchInterface $currentRouteMatch
  ) {}

  /**
   * {@inheritdoc}
   */
  public static function getLabel() {
    return $this->t('Module or activity from route.');
  }

  /**
   * {@inheritdoc}
   */
  public function getContext($parameter = NULL): string {
    $entity = $this->getEntityFromRoute($parameter);
    if ($entity === NULL) {
      return '';
    }

    return $entity->id();
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheableMetadata($parameter = NULL) {
    return new CacheableMetadata();
  }

}
