<?php

declare(strict_types=1);

namespace Drupal\opigno_learning_path\Context;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\opigno_module\Entity\OpignoActivity;
use Drupal\opigno_module\Entity\OpignoModule;

/**
 * Common training context logic.
 */
trait TrainingContextTrait {

  /**
   * Context ID -> entity type ID mapping.
   */
  protected array $mapping = [
    'opigno_module' => 'opigno_module',
    'opigno_activity' => 'opigno_activity',
  ];

  /**
   * Helper method to get entity from route.
   */
  protected function getEntityFromRoute(string $parameter): ?ContentEntityInterface {
    $entity = $this->currentRouteMatch->getParameter($this->mapping[$parameter]);
    if (
      !$entity instanceof OpignoModule &&
      !$entity instanceof OpignoActivity
    ) {
      return NULL;
    }

    // @todo Will we need to load entities here in some cases (Views routes)?
    return $entity;
  }

}
