<?php
/**
 * @file
 * Post update functions for the aft_lms module.
 */

use Drupal\Core\Site\Settings;

/**
 * Update hard-coded 100 50 10 scores to 10 5 1.
 */
function opigno_pass_fail_post_update_update_scores(&$sandbox) {
  $entity_type_manager = \Drupal::service('entity_type.manager');
  if (!isset($sandbox['ids'])) {
    $activity_ids = $entity_type_manager->getStorage('opigno_activity')->getQuery()
      ->accessCheck(FALSE)
      ->condition('opigno_evaluation_method', 1)
      ->execute();

    if (!empty($activity_ids)) {
      $answer_ids = $entity_type_manager->getStorage('opigno_answer')->getQuery()
        ->accessCheck(FALSE)
        ->condition('activity', $activity_ids, 'IN')
        ->execute();

      $sandbox['ids'] = $answer_ids;
      $sandbox['max'] = count($sandbox['ids']);
      $sandbox['progress'] = 0;
    }
    else {
      $sandbox['#finished'] = 1;
      return;
    }
  }

  $answer_ids = array_slice($sandbox['ids'], $sandbox['progress'], Settings::get('entity_update_batch_size', 50));
  $answers = $entity_type_manager->getStorage('opigno_answer')->loadMultiple($answer_ids);

  foreach ($answers as $answer) {
    if ($answer->getScore() == 10) {
      $answer->setScore(1);
    }
    elseif ($answer->getScore() == 100) {
      $answer->setScore(10);
    }
    elseif ($answer->getScore() == 50) {
      $answer->setScore(5);
    }
    $answer->save();
    $sandbox['progress']++;
  }
  $sandbox['#finished'] = empty($sandbox['max']) ? 1 : ($sandbox['progress'] / $sandbox['max']);
}

