<?php

namespace Drupal\opigno_team_activity\EventSubscriber;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * LMS group activity route subscriber.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if ($route = $collection->get('view.team_activity_entries.page_1')) {
      $parameters = $route->getOption('parameters');
      $parameters['group']['bundle'] = ['learning_path'];
      $route->setOption('parameters', $parameters);
    }
    if ($route = $collection->get('view.team_activity_entries.page_2')) {
      $parameters = $route->getOption('parameters');
      $parameters['group']['bundle'] = ['learning_path'];
      $route->setOption('parameters', $parameters);
      $route->setRequirement('_custom_access', '_opigno_team_activity_my_team_activity_access');
    }
  }

}
